'RelDil_V02b.bas   24.08.2013
'*********************************************************************************

'--------------------  Definitionen  --------------------------------

$regfile = "M8adef.dat"                                     ' Prozessortyp
$crystal = 8000000                                          '  mu drin sein (fr TWI calculation?)
                                                            '  verwendet wird aber interner Oszillator !
$framesize = 32                                             ' Frames
$swstack = 32                                               ' Software stack
$hwstack = 32                                               ' Hardware stack

Config Twislave = &H66 , Btr = 4 , Bitrate = 100000         ' Adresse = 102 / Btr = 4 / 100kHz
$lib "i2c_twi.lbx"                                          ' ist Teil der "i2c_slave.lib"
Config Scl = Portc.5                                        ' wirklich notwendig ??
Config Sda = Portc.4

'-------------------------- I2C Bus berwachung -------------------------------
Dim Timeout As Word                                         ' Zhler fr Bus timeout
Dim Ereignisse As Word                                      ' Zhler fr reset-Ereignisse ###########################

'-------------------- fr Relaissteuerung --------------------------------------
Config Portc = Output
Portc = 0                                                   ' alle aus
Config Portd = Output
Portd = 0                                                   ' alle aus

Dim Masterbyte As Byte                                      ' bernimmt _a1 von den i2c-Routinen
Dim Rel(14) As Byte                                         ' Relaisstatus als byte-Array
Dim Mbcount As Bit                                          ' erstes (0) oder zweites (1) command byte ?
Dim Command As Bit                                          ' Kommando komplett (1) oder nicht (0)
Dim Rstatus As Bit
Dim V As Byte                                               ' als Zhlvariable beim slave-transmit
Dim N As Byte , I As Byte                                   ' Zhlvariable
Dim Rueckmeldung1 as Byte
Dim Rueckmeldung2 as Byte

'-------------- Initialisierung ---------------------------------------------
For N = 1 To 12                                             ' array auf OFF (vorsichtshalber)
   Rel(n) = 0                                               ' NOTWENDIG ???
Next N

Enable Interrupts                                           ' nicht vergessen !

'-------------- Main --------------------------------------

Mbcount = 0
Command = 0

Do
   If Command = 1 Then                                      '
      Select Case I
         Case 0
            Rstatus = Rel(i)
            If Rstatus = 1 Then
               Portd = 255                                    ' alle Relais ein
               Portc = 15
               For N = 1 To 12                                             ' array auf OFF (vorsichtshalber)
                  Rel(n) = 1                                               ' NOTWENDIG ???
               Next N
            Else
               Portd = 0                                      ' alle Relais aus
               Portc = 0
               For N = 1 To 12                                             ' array auf OFF (vorsichtshalber)
                  Rel(n) = 0                                               ' NOTWENDIG ???
               Next N
            End If                                           '
         Case 1                                             ' Hardware-Relais 1
            Portc.3 = Rel(i)
         Case 2
            Portc.2 = Rel(i)
         Case 3
            Portc.1 = Rel(i)
         Case 4
            Portc.0 = Rel(i)
         Case 5                                             '
            Portd.7 = Rel(i)
         Case 6
            Portd.6 = Rel(i)                                ' ... 6
         Case 7
            Portd.5 = Rel(i)                                ' ... 7
         Case 8
            Portd.4 = Rel(i)                                ' ... 8
         Case 12
            Portd.0 = Rel(i)                                '
         Case 11
            Portd.1 = Rel(i)                                '
         Case 10
            Portd.2 = Rel(i)                                '
         Case 9
            Portd.3 = Rel(i)                                '
      End Select
      Rueckmeldung1.0=Rel(4)     'PortC
      Rueckmeldung1.1=Rel(3)
      Rueckmeldung1.2=Rel(2)
      Rueckmeldung1.3=Rel(1)

      Rueckmeldung2.0=Rel(9)     'PortD
      Rueckmeldung2.1=Rel(10)
      Rueckmeldung2.2=Rel(11)
      Rueckmeldung2.3=Rel(12)
      Rueckmeldung2.4=Rel(8)
      Rueckmeldung2.5=Rel(7)
      Rueckmeldung2.6=Rel(6)
      Rueckmeldung2.7=Rel(5)
      Command = 0
   End If

'----------  I2C-Wchter --------------------------
'   If Pinc.4 = 1 And Pinc.5 = 1 Then Timeout = 0

'   Portd.6 = 1                                              ' Rel 6 #########################
'   Portd.5 = 1                                              ' Rel 7
'   Portd.4 = 1                                              ' Rel 8

'   If Pinc.4 = 0 Then Incr Timeout
'   If Pinc.5 = 0 Then Incr Timeout

'   If Timeout > 1000 Then
'      Portd.6 = 0                                           ' #############################
'      Portd.5 = 0
'      Portd.4 = 0
'      Timeout = 0
'      Incr Ereignisse                                       '                                       '
'      Wait 1
'   End If

   Waitms 5                                                 '

   'Gosub Twi_gotdata                              ' debugging only
Loop
End

'---------------------------------------------------------------------------

Twi_gotdata:
   Masterbyte = Twi
   If Masterbyte = 65 Then                                  ' analog Vmux und Amux
      Goto Raus1
'      V = 1                                                 ' Zhlvariable zum Abfragen
   Else
      If Command = 0 Then
         If Mbcount = 0 Then
            I = Masterbyte
            Mbcount = 1
         Else
            Rel(i) = Masterbyte
            Mbcount = 0
            Command = 1
         End If
      End If
   End If
Raus1:
Return
''--------------------------------------------------------------------------------------------------
Twi_master_needs_byte:                                      ' Abfrage von PortD, PortC und Timeoutzhler mit Twi_btr als Index
   Select Case Twi_btr
'   Select Case V
      Case 1
         Twi = Rueckmeldung2
      Case 2
         Twi = Rueckmeldung1
      Case 3                                                ' Abfrage: Zahl der Reset Ereignisse
         Twi = High(ereignisse)
      Case 4
         Twi = Low(ereignisse)
   End Select
'   V = V + 1
Return

''------------------------------- die folgenden werden vom Compiler erwartet aber hier nicht genutzt
Twi_stop_rstart_received:
   nop
Return
Twi_addressed_goread:
   nop
Return
Twi_addressed_gowrite:
   nop
Return
Twi_master_need_nomore_byte:
   nop
Return
''------------------------------------------------------------------------------------------------